<script setup lang="ts">
import GitLabApi from '@/api/gitApi'
import UserApiV1 from '@/api/userApi'
import { onMounted, reactive, ref, watch } from 'vue'

import AddGitlabIntegration from '@/components/forms/GitLabIntegration/AddGitlabIntegration.vue'
import GitlabIntegrationUser from '@/components/forms/GitLabIntegration/GitlabIntegrationUser.vue'
import GitlabUser from '@/components/forms/GitLabIntegration/GitlabUser.vue'
import NoGitlabUser from '@/components/forms/GitLabIntegration/NoGitlabUser.vue'

// let user = JSON.parse(sessionStorage.getItem('user')) || ''; // Lee el token del localStorage;

// Definir las propiedades del componente
const props = defineProps({
  userData: {
    type: Object,
    default: () => ({ id: 0, name: '', email: '' }), // Suponiendo que userData tiene más campos
  },
})

// Crear una copia reactiva de userData para poder modificarla
const user = reactive({ ...props.userData })

const username_prefix = ref(window.GITLAB_USERNAME_PREFIX)

const isSelfManagement = ref(false) // Assuming a prop or reactive state
const gitlabUser = ref({})
const hasGitlabUser = ref(false)
const gitlabIntegrationUser = ref({})
const hasGitlabIntegrationUser = ref(false)
const requestMessage = ref('')
const isError = ref(false)

const refresh = () => {
  integrationFlow()
}

// ℹ️ onMounted
onMounted(() => {
  console.debug('DEBUG: mounted GitLabIntegrationFormAdmin')
  integrationFlow()
})

// ℹ️ watch
watch(user, () => {
  console.log(`Watching for changes in user ${props.userData.value}`)
  integrationFlow()
})

// ℹ️ Methods
const integrationFlow = async () => {
  await getGitlabIntegrationUser()
  console.debug('DEBUG: integrationFlow [hasGitlabIntegrationUser.value]: ', hasGitlabIntegrationUser.value)
  if (!hasGitlabIntegrationUser.value)
    await getGitlabUser()
}

const getGitlabUser = async () => {
  console.info('INFO: getGitlabUser')

  const gitlab = new GitLabApi()

  hasGitlabUser.value = false
  try {
    // TODO: Need to be extenalize
    let { username } = user

    if (username_prefix.value !== null && username_prefix.value !== undefined)
      username = `${username_prefix.value}_${props.userData.username}`

    console.debug('DEBUG: Get gitlabUser username:', username)
    const response = await gitlab.getUserByUserName(username)

    console.debug('DEBUG: getGitlabUser response.data: ', response.data)
    if (response.data[0] !== undefined) {
      gitlabUser.value = response.data[0]
      hasGitlabUser.value = true
    }
  }
  catch (error) {
    console.error('error getGitlabUser', error.response.data)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
}

const getGitlabIntegrationUser = async () => {
  console.info('INFO: getGitlabIntegrationUser')
  console.info('user.value.id', user.id)

  const api = new UserApiV1()

  hasGitlabIntegrationUser.value = false
  try {
    const response = await api.getGitUserById(props.userData.id)

    console.info('getGitlabIntegrationUser response.data: ', response.data)
    gitlabIntegrationUser.value = response.data.data
    hasGitlabIntegrationUser.value = true
    hasGitlabUser.value = false
  }
  catch (error) {
    console.debug('ERROR: error', error)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
}
</script>

<template>
  <VRow>
    <!-- 👉 Message Title and subtitle -->
    <VCol cols="12">
      <h6 class="text-h6 font-weight-medium">
        GitLab Integration [{{ props.userData.username }}] - ({{ props.userData.id }})
      </h6>
      <p class="mb-0">
        Sync your ANA Framework account with your gitlab account.
      </p>
    </VCol>
  </VRow>

  <!--
    p> +++++++++++++++++++++++++++++++++ </p>
    <p> user {{ props.userData }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> user.id {{ props.userData.id }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> gitlabUser {{ gitlabUser }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> gitlabIntegrationUser {{ gitlabIntegrationUser }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> hasGitlabUser {{ hasGitlabUser }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> hasGitlabIntegrationUser {{ hasGitlabIntegrationUser }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p>
    <p> isSelfManagement {{ isSelfManagement }} </p>
    <p> +++++++++++++++++++++++++++++++++ </p
  -->

  <VRow>
    <VCol cols="12">
      <!-- v-if="hasGitlabUser" -->
      <GitlabUser
        v-if="hasGitlabUser"
        :user="user"
        :gitlab-user="gitlabUser"
        @created="refresh"
      />
      <!-- v-else-if="hasGitlabIntegrationUser" -->
      <GitlabIntegrationUser
        v-else-if="hasGitlabIntegrationUser"
        :gitlab-integration-user="gitlabIntegrationUser"
        @modified="refresh"
      />
      <!--  v-else-if="isSelfManagement && ['admin', 'root'].includes(user.role.toLowerCase())" -->
      <AddGitlabIntegration v-else-if="isSelfManagement && ['admin', 'root'].includes(user.role.toLowerCase())" />
      <!-- v-else -->
      <NoGitlabUser
        v-else
        :user="user"
        @finished="refresh"
      />
    </VCol>
  </VRow>
</template>

<style scoped>
</style>
